require(['jquery'], function ($) {
$(function(){
  var NESTED_SPACES = checkNestedSpaces();
  var currentPage = encodeURIComponent(XWiki.currentPage);
  var currentSpace = encodeURIComponent(XWiki.currentSpace);
  var currentPageEscaped = encodeURIComponent(XWiki.currentPage.replace(/\\/g, '\\\\').replace(/\./g, '\\\.'));
  var currentSpaceEscaped = encodeURIComponent(getSpacesEscaped(XWiki.currentSpace));
  if(XWiki.webapppath.substr(0,1) === '/') {
    XWiki.webapppath = XWiki.webapppath.substr(1,(XWiki.webapppath.length-1));
  }
  var wikiViewURL = '/'+XWiki.webapppath+''+XWiki.servletpath+'view/';
  if(window.docviewurl.indexOf('/'+XWiki.currentSpace+'/') >= 0) {
    wikiViewURL = window.docviewurl.substring(0,window.docviewurl.indexOf('/'+XWiki.currentSpace+'/')+1);
  }
  var wikiEditURL = '/'+XWiki.webapppath+''+XWiki.servletpath+'edit/';
  if(window.docediturl.indexOf('/'+XWiki.currentSpace+'/') >= 0) {
    wikiGetURL = window.docediturl.substring(0,window.docediturl.indexOf('/'+XWiki.currentSpace+'/')+1);
  }
  var hashURL = window.location.hash.substring(1).split('&!!');
  // Determine if that page is part of a project. Add the XWebIDE link in the Actions menu if that's the case and the "W" shortcut to use the XWebIDE editor.
  $.ajax({
    url: wikiViewURL+"WebIDECode/ApplicationCheck?xpage=plain&outputSyntax=plain&doc="+currentSpaceEscaped+"."+currentPageEscaped,
    type: "GET",
    contentType: "application/json",
  }).success(function(data){
    if(data.error == "-1") { // Type = 1, Is the page part of a project?
      if(XWiki.contextaction == 'edit' || XWiki.contextaction == 'view') {
        $('#tmEdit .dropdown-menu .divider:first').before('<li class=""><a href="#" id="tmEditWebIDE" class="tmEditXWebIDE" title="Edit '+data.documentName+' in XWebIDE"><span class="glyphicon  glyphicon-folder-open"></span> XWebIDE</a></li>');
        $('.tmEditXWebIDE').click(function(e) {
          e.preventDefault();
          loadMasterPage(1);
        });
      }
      shortcut.add("W", function() {
        loadMasterPage(1);
      } ,{'disable_in_input':'true'});

      // Display the hierarchy if the hash is in the URL
      if(XWiki.contextaction == 'edit' && window.location.hash && !hierarchyStatus) {
        if(hashURL[0] == '!XWebIDE') {
          if(hashURL.size() >= 3) {
            var hashSpace = decodeURIComponent(hashURL[1]);
            var hashPage = decodeURIComponent(hashURL[2]);
            for(var i=0; i<data.projectData.length; i++) {
              if(data.projectData[i].masterSpace === hashSpace && data.projectData[i].masterName === hashPage) {
                var masterSpace = data.projectData[i].masterSpace;
                var masterName = data.projectData[i].masterName;
                break;
              }
            }
          }
          else {
            var masterSpace = data.projectData[0].masterSpace;
            var masterName = data.projectData[0].masterName;
          }
          displayHierarchy(masterSpace, masterName);
        }
      }
    }
    else {
      if(XWiki.contextaction == 'edit' || XWiki.contextaction == 'view') {
        $('#tmEdit .dropdown-menu .divider:first').before('<li class=""><a href="#" id="tmEditWebIDE" class="tmEditXWebIDE" title="Edit '+XWiki.currentPage+' in XWebIDE"><span class="glyphicon  glyphicon-folder-open"></span> XWebIDE</a></li>');
        $('.tmEditXWebIDE').click(function(e) {
          e.preventDefault();
          loadMasterPage(1);
        });
      }
      shortcut.add("W", function() {
        loadMasterPage(1);
      } ,{'disable_in_input':'true'});
    }

    if(data.sheetError == "-1") { // Type = 2, Does the page use a sheet which is part of a project?
      if(XWiki.contextaction == 'edit' || XWiki.contextaction == 'view') {
        $('#tmEdit .dropdown-menu .divider').before('<li class=""><a href="#" id="tmEditWebIDE" class="tmEditXWebIDESheet" title="Edit the sheet of '+data.documentName+' in XWebIDE"><span class="glyphicon  glyphicon-folder-open"></span> XWebIDE (Sheet)</a></li>');
        $('.tmEditXWebIDESheet').click(function(e) {
          e.preventDefault();
          loadMasterPage(2);
        });
      }
      shortcut.add("Shift+W", function() {
        loadMasterPage(2);
      } ,{'disable_in_input':'true'});
    }

    function loadMasterPage(checkType) {
      if(checkType == 1 && data.size == "1") {
        window.location.href = wikiViewURL+encodeURI(getURLSpacesString(unescape(data.projectData[0].masterSpace)))+'/'+encodeURIComponent(unescape(data.projectData[0].masterName))+'#!XWebIDE&!!wiki&!!logical&!!'+currentPage+'&!!'+currentSpace+'&!!default';
      }
      else if(checkType === 1 && data.error == "1") {
        window.location.href = wikiViewURL+'WebIDECode/DefaultProject#!XWebIDE&!!wiki&!!logical&!!'+currentPage+'&!!'+currentSpace+'&!!default';
      }
      else if(checkType == 2 && data.sheetSize == "1") {
        window.location.href = wikiViewURL+encodeURI(getURLSpacesString(unescape(data.sheet[0].sheetProjectData[0].sheetMasterSpace)))+'/'+encodeURIComponent(unescape(data.sheet[0].sheetProjectData[0].sheetMasterName))+'#!XWebIDE&!!wiki&!!logical&!!'+encodeURIComponent(unescape(data.sheet[0].sheetDocumentName))+'&!!'+encodeURIComponent(unescape(data.sheet[0].sheetDocumentSpace))+'&!!default';
      }
      else if(parseInt(data.size) > 1 || parseInt(data.sheetSize) > 1){
        var message = 'That page is in several projects. Which one do you want to edit?';
        var projectURLList = '';
        if(checkType == 1) {
          $.each(data.projectData, function(key, value) {
            projectURLList += '<a href="'+wikiViewURL+getURLSpacesString(value.masterSpace)+'/'+value.masterName+'#!XWebIDE&!!wiki&!!logical&!!'+currentPage+'&!!'+currentSpace+'&!!default" id="tmEditWebIDE" class="tmEditXWebIDE" title="Edit '+data.documentName+' in XWebIDE as part of '+value.project+'">Edit <strong>'+data.documentName+'</strong> in project <strong>'+value.project+'</strong></a><br />';
          });
        }
        else if(checkType == 2) {
          message = 'That page uses sheets from several projects. Which project do you want to edit?';
          $.each(data.sheet, function(keySheet, valueSheet) {
            $.each(valueSheet.sheetProjectData, function(key, value) {
              projectURLList += '<a href="'+wikiViewURL+getURLSpacesString(value.sheetMasterSpace)+'/'+value.sheetMasterName+'#!XWebIDE&!!wiki&!!logical&!!'+valueSheet.sheetDocumentName+'&!!'+valueSheet.sheetDocumentSpace+'&!!default" id="tmEditWebIDE" class="tmEditXWebIDE" title="Edit '+valueSheet.sheetDocumentName+' in XWebIDE as part of '+value.sheetProject+'">Edit <strong>'+valueSheet.sheetDocumentName+'</strong> in project <strong>'+value.sheetProject+'</strong></a><br />';
            });
          });
        }
        $('#modalProjectSelection').remove();
        $('<div id="modalProjectSelection" class="modal fade" role="dialog"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><button type="button" class="close" data-dismiss="modal">&times;</button><h4 class="modal-title">XWebIDE editor</h4></div><div class="modal-body"><p>'+message+'</p><p>'+projectURLList+'</p></div><div class="modal-footer"><button type="button" class="btn btn-default" data-dismiss="modal">Close</button></div></div></div></div>').appendTo('body');
        $('#modalProjectSelection').modal('show');
      }
    }

  });

  /**
   * Check if Nested spaces are available if that version of XWiki
   * @return boolean
   */
  function checkNestedSpaces() {
    if(XWiki.EntityReferenceTreeNode)
      return true;
    else
      return false;
  }

  /**
   * @param spaces The string describing spaces with XWiki classic format 'A.B'
   * @return The string describing spaces with XWiki URL format 'A/B'
   */
  function getURLSpacesString(spaces) {
    if(NESTED_SPACES) {
      var spacesEsc = spaces.replace(/%5C\./g, '%5C%2E').replace(/\\\./g, '%5C%2E');
      var spacesList = spacesEsc.split('.');
      var restFormat = '';
      for(var i=0; i<spacesList.length; i++) {
        restFormat += spacesList[i].replace('%5C%2E', '\.')+'/';
      }
      return restFormat.substring(0, restFormat.length - 1);
    }
    else return spaces;
  }

  /**
   * @param spaces The string describing a space with XWiki classic format 'A.B' (without nested space)
   * @return The string describing escaped space name 'A\.B'
   */
  function getSpacesEscaped(spaces) {
    if(NESTED_SPACES) {
      return spaces;
    }
    else return spaces.replace('%5C', '%5C%5C').replace(/\\/g, '%5C%5C').replace(/\./g, '%5C.');
  }
});
});
